# -*- coding: utf8 -*-


import urllib
from sgmllib import SGMLParser


class Catalog(SGMLParser):
    def __init__(self, address):
        SGMLParser.__init__(self)
        self.is_div = False
        self.is_dd = False
        self.is_a = False
        self.catalog = []
        self.catalog_addr = []
        self.address = address
        
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == 'book_article_listtext':
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        
    def start_dd(self, attrs):
        if self.is_div:
            self.is_dd = True
            
    def end_dd(self):
        self.is_dd = False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_dd:
            self.is_a = True          
            self.catalog_addr.append(self.address.replace("index.html",ad.get('href')))
        
    def end_a(self):
        self.is_a = False
        
    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data.strip())
        
        
class Content(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.content = []
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('id') == "booktext":
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        
    def handle_data(self, data):
        if self.is_div:
            self.content.append(data)



def getCatalog(string,url):
    catalog=Catalog(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent
