# -*- coding: utf8 -*-

import sgmllib
from sgmllib import SGMLParser

class QiDian(SGMLParser):
    def __init__(self,*l):
        SGMLParser.__init__(self)
        self.is_div=False       
        self.is_a=False
        self.is_span=False
        self.Continue=False
        self.catalog_addr=[]
        self.vipCatalog=[]
        self.catalog=[]
        

    def start_div(self, attrs):
        ad=dict(attrs)
        if ad.get('class')=='box_cont':
            self.is_div = True

        if  self.is_div==True:
            if ad.get('class')=='intro':
                self.Continue=True                
            if ad.get('class')=='list':
                self.Continue=False
            pass
            
    def end_div(self):
        if not self.Continue:
            self.is_div = False
        pass

    
    def start_a(self, attrs):
        ad=dict(attrs)
        if self.is_div:
            if not ad.get('target')=='_blank':
                self.catalog_addr.append(ad.get('href'))
                self.is_a = True           
                pass
            
    def end_a(self):
        self.is_a = False
        pass
    
    def start_span(self, attrs):
        ad=dict(attrs)
        if ad.get('itemprop')=='headline':
            self.is_span = True
         
    def end_span(self):
        self.is_span=False
        pass
    
    def handle_data(self,text):
        if self.is_span:
            self.catalog.append(text)


            
class Content(SGMLParser):
    def __init__(self,*l):
        SGMLParser.__init__(self)
        self.is_div1=False
        self.is_div2=False
        self.is_h1=False
        self.is_script=False
        self.getTitle=False
        self.title=''
        self.content=[]
        
    def start_div(self, attrs):
        ad=dict(attrs)
        if ad.get('class')=='story_title':
            self.is_div1 = True
        if ad.get('class')=='bookreadercontent' and ad.get('id')=='chaptercontent':
            self.is_div2 = True 
            pass
            
    def end_div(self):
        self.is_div1 = False
        self.is_div2 = False
        pass

    def start_h1(self, attrs):
        ad=dict(attrs)
        if self.is_div1:
            self.is_h1 = True           
            pass
            
    def end_h1(self):
        self.is_h1 = False
        pass
    
    def start_script(self, attrs):
        ad=dict(attrs)
        if self.is_div2:
            if not ad.get('src')==None:
                self.content=ad.get('src')
            self.is_script = True           
            pass
            
    def end_script(self):
        self.is_script = False
        pass
    
    def handle_data(self,text):
        if not self.getTitle and self.is_h1:           
            self.title=text
            self.getTitle=True



def getCatalog(string):
    catalog=QiDian()
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        if "vipreader" not in c:
            caStr+=c
            caStr+='\n'
    return caStr

def catalogUrlMM(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        if "vipreader" not in c:
            caStr=caStr+'http://www.qdmm.com'+c
            caStr+='\n'
    return caStr

def getContentUrl(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent=''
    for str in con.content:
        if str:
            allcontent=allcontent+str
    return allcontent 


def getContent(string):
    content=string.replace('<p>','\n')
    return content
    
