# -*- coding: utf8 -*-

from sgmllib import SGMLParser


class Catalog(SGMLParser):
    def __init__(self,rurl):
        SGMLParser.__init__(self)

        self.is_td=False
        self.is_a=False
     
        self.readUrl=rurl
        self.contentUrl=[]
        self.cataLog=[]
             
         
    def start_td(self, attrs):
        ad=dict(attrs)
        if ad.get("class") == 'L':
            self.is_td=True
               
    def end_td(self):
        self.is_td= False
        pass
         
    def start_a(self, attrs):
        ad=dict(attrs)
        if self.is_td:
            if "html" in ad.get('href'):
                self.contentUrl.append('http://www.23us.so'+ad.get('href'))
            self.is_a = True           
             
                 
    def end_a(self):
        self.is_a = False
        pass
               
    def handle_data(self,text):
        if self.is_a:
	    if text.strip():
	        self.cataLog.append(text.strip())

    
class Content(SGMLParser):
    def __init__(self,*l):
        SGMLParser.__init__(self)
        self.is_dd=False
        self.content=[]
       
    def start_dd(self, attrs):
        ad=dict(attrs)
        if ad.get('id')=='contents':
            self.is_dd=True
              
    def end_dd(self):
        self.is_dd= False
        pass
        
    def handle_data(self,text):
        if self.is_dd:
            if text.strip():
                self.content.append(text)
   
    


def getCatalog(string,url):
    catalog=Catalog(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.cataLog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.contentUrl:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent(string):
    con=Content()
    con.feed(string)
    allcontent='      '
    for str in con.content:
        allcontent=allcontent+str+'\n'+"       "
       
    return allcontent


