# -*- coding: utf8 -*-
u'''
@summary:
@author: Administrator
@date: 2016年2月19日
'''

from sgmllib import SGMLParser


class Catalog(SGMLParser):
    def __init__(self, address):
        SGMLParser.__init__(self)
        self.is_div = False
        self.is_dd = False
        self.is_a = False
        self.catalog = []
        self.catalog_addr = []
        self.address = address
        
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == 'box_con':
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        
    def start_dd(self, attrs):
        if self.is_div:
            self.is_dd = True
            
    def end_dd(self):
        self.is_dd= False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_dd:
            self.is_a = True          
            self.catalog_addr.append('http://www.3dllc.cc'+ ad.get('href'))
        
    def end_a(self):
        self.is_a = False
        
    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data)
        
        
class Content1(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.content = []
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('id') == "content":
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        pass
        
    def handle_data(self, data):        
        if self.is_div:
            self.content.append(data.strip().replace('><br','').replace('>',''))

class Content2(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.content = []
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == "zhang-txt-nei-rong":
           self.is_div = True
        if ad.get('class') == "bd-load-s":
           self.is_div = False
            
    def end_div(self):
        pass
    #    self.is_div = False
        
    def handle_data(self, data):        
        if self.is_div:
            self.content.append(data.strip().replace('><br','').replace('>',''))


def getCatalog(string,url):
    catalog=Catalog(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent1(string):
    con=Content1()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent

def getContent2(string):
    con=Content2()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent

def getContent(string):
    content1 = getContent1(string)
    content2 = getContent2(string)
    if len(content1) > len(content2):
        return content1
    else:
        return content2



