# -*- coding: utf8 -*-
u'''
@summary:
@author: Administrator
@date: 2016年1月28日
'''


import urllib
from sgmllib import SGMLParser

class PaoShu(SGMLParser):
    def __init__(self, url):
        SGMLParser.__init__(self)
        self.is_div = False
        self.is_dd = False
        self.is_a = False
        self.url = url
        self.catalog_addr = []
        self.catalog = []
       
    def start_div(self, attrs):
        ad = dict(attrs) 
        if ad.get('id') == 'list':
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        
    def start_dd(self, attrs):
        if self.is_div:
            self.is_dd = True
    
    def end_dd(self):
        self.is_dd = False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_dd:
            self.is_a = True
            self.catalog_addr.append(self.url + ad.get('href'))
            
    def end_a(self):
        self.is_a = False
        
    
    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data)
    
    
def getcatalog(url):
    ps = PaoShu(url)
    res = urllib.urlopen(url)
    ps.feed(res.read())
   
    return ps.catalog_addr, ps.catalog
    

class Content(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.pro_index = 0
        self.content = []
        
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if self.is_div == True:
            self.pro_index += 1
            
        if ad.get('class') == "zhangjieTXT":
            
            self.is_div = True
            
    def end_div(self):
        if self.pro_index == 0:
            self.is_div = False
            
        if self.is_div == True:
            self.pro_index -= 1
            
    
    def handle_data(self, data):
        if self.is_div == True and self.pro_index == 0:
            
            self.content.append(data.replace('showmidbar();', '').strip().replace('reads();',''))
            

def getCatalog(string,url):
    catalog=PaoShu(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent
    

