# -*- coding: utf8 -*-
u'''
@summary:
@author: Administrator
@date: 2016年1月28日
'''

import urllib
from sgmllib import SGMLParser


class AiShang(SGMLParser):
    
    def __init__(self, url):
        SGMLParser.__init__(self)
        self.url = url
        self.is_li = False
        self.is_a = False
        self.catalog_addr = []
        self.catalog = []
        
    def start_li(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == 'zp_li' or ad.get('class') == "zp_li zp_rno":
            self.is_li = True

    def end_li(self):
        self.is_li = False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_li:
            address = self.url.replace('index.html', ad.get('href'))
            self.catalog_addr.append(address)
            self.is_a = True
            
    def end_a(self):
        self.is_a = False

    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data.strip())

    
def getcatalog(url):
    ais = AiShang(url)
    res = urllib.urlopen(url)
    ais.feed(res.read())
    
    return ais.catalog_addr[8:], ais.catalog[8:]
    
class Content(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_dd = False
        self.content = []
        
    def start_dd(self, attrs):
        ad = dict(attrs)
        if ad.get('id') == 'contents':
            self.is_dd = True
            
    def end_dd(self):
        self.is_dd = False
        
        
    def handle_data(self, data):
        if self.is_dd:
            self.content.append(data)
        
        
        
def getcontent(url): 
    catalog_addr, _catalog = getcatalog(url)     
    for address in catalog_addr:
        ct = Content()
        res = urllib.urlopen(address)
        ct.feed(res.read())
       
        return ct.content


def getCatalog(string,url):
    catalog=AiShang(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent='    '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"    "
    return allcontent

        
