# -*- coding: utf8 -*-
u'''
@summary:
@author: Administrator
@date: 2016年2月19日
'''
import urllib
from sgmllib import SGMLParser


class Catalog(SGMLParser):
    def __init__(self, address):
        SGMLParser.__init__(self)
        self.is_u1 = False
        self.is_li = False
        self.is_a = False
        self.catalog = []
        self.catalog_addr = []
        self.address = address
        
        
    def start_ul(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == 'pox':
            self.is_u1 = True
            
    def end_ul(self):
        self.is_u1 = False
        
    def start_li(self, attrs):
        if self.is_u1:
            self.is_li = True
            
    def end_li(self):
        self.is_li= False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_li:
            self.is_a = True          
            self.catalog_addr.append(self.address+ ad.get('href'))
        
    def end_a(self):
        self.is_a = False
        
    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data)
        
        
class Content(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.content = []
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == "zhang-txt-nei-rong":
           self.is_div = True
        if ad.get('class') == "bd-load-s":
           self.is_div = False
            
    def end_div(self):
        pass
    #    self.is_div = False
        
    def handle_data(self, data):        
        if self.is_div:
            self.content.append(data.strip().replace('><br','').replace('>',''))



def getCatalog(string,url):
    catalog=Catalog(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    for c in catalog.catalog:
        caStr+=c
        caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr

def getContent(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent


