# -*- coding: utf8 -*-
u'''
@summary:
@author: Administrator
@date: 2016年2月26日
'''
import urllib
from sgmllib import SGMLParser

class Catalog(SGMLParser):
    def __init__(self, address):
        SGMLParser.__init__(self)
        self.is_td = False
        self.is_a = False
        self.catalog = []
        self.catalog_addr = []
        self.address = address
        
    def start_td(self, attrs):
        ad = dict(attrs)
        if ad.get('class') == 'ccss':
            self.is_td = True
            
    def end_td(self):
        self.is_td = False
        
    def start_a(self, attrs):
        ad = dict(attrs)
        if self.is_td:
            self.is_a = True
            self.catalog_addr.append(self.address + ad.get('href'))
            
    def end_a(self):
        self.is_a = False
        
    def handle_data(self, data):
        if self.is_a:
            self.catalog.append(data)


class Content(SGMLParser):
    def __init__(self):
        SGMLParser.__init__(self)
        self.is_div = False
        self.content = []
        
    def start_div(self, attrs):
        ad = dict(attrs)
        if ad.get('id') == 'ccontent':
            self.is_div = True
            
    def end_div(self):
        self.is_div = False
        
    def handle_data(self, data):
        if self.is_div:
        
            self.content.append(data)    
        
def getCatalog(string,url):
    catalog=Catalog(url)
    catalog.feed(string)
    return catalog

def catalogName(catalog):
    caStr=''
    content = []
    for c in catalog.catalog:
        if c:
            content.append(c)
    for c in content:
            caStr+=c
            caStr+='\n'
    return caStr

def catalogUrl(catalog):
    caStr=''
    for c in catalog.catalog_addr:
        caStr+=c
        caStr+='\n'
    return caStr


def getContent(string):
    con=Content()
    con.feed(string)
    content = []
    allcontent='     '
    for str in con.content:
        if str:
            allcontent=allcontent+str+'\n'+"     "
    return allcontent
        
